#include <iostream>

class Base {
public:
    virtual void print() { std::cout << "Base" << std::endl; }
    virtual ~Base() {}
};

class Derived : public Base {
public:
    void print() override { std::cout << "Derived" << std::endl; }
};

int main() {
    Base* basePtr = new Derived();
    basePtr->print();  // Prints "Derived"

    // Downcasting
    Derived* derivedPtr = static_cast<Derived*>(basePtr);
    derivedPtr->print();  // Prints "Derived"

    delete basePtr;
    return 0;
}
